searchNodes=[{"doc":"This library wraps Erlang/OTP's SSH daemon to make it easier to use reliably with Nerves devices.Most importantly, it makes it possible to segment failures in other OTP applications from terminating the daemon and it recovers from rare scenarios where the daemon terminates without automatically restarting.If you're using :nerves_pack v0.4.0 or later, you don't need to do anything except, perhaps, modify the :nerves_ssh's configuration in your config.exs. If you are not using :nerves_pack, add :nerves_ssh to your mix dependency list:def deps do [ {:nerves_ssh, &quot;~&gt; 0.1.0&quot;, targets: @all_targets} ] endAnd then include it in :shoehorn's :init list:config :shoehorn, init: [:nerves_runtime, :vintage_net, :nerves_ssh]:nerves_ssh will work if you do not add it to the :init list. However, if your main OTP application stops, OTP may stop :nerves_ssh, and that would make your device inaccessible via SSH.ConfigurationNervesSSH supports a few pieces of configuration via the application config::authorized_keys - a list of SSH authorized key file string:user_passwords - a list of username/password tuples (stored in the clear!):port - the TCP port to use for the SSH daemon. Defaults to 22.:subsystems - a list of SSH subsystems specs to start. Defaults to SFTP and ssh_subsystem_fwup:system_dir - where to find host keys:shell - the language of the shell (:elixir, :erlang, or :disabled). Defaults to :elixir.:exec - the language to use for commands sent over ssh (:elixir, :erlang, or :disabled). Defaults to :elixir.:iex_opts - additional options to use when starting up IEx:daemon_option_overrides - additional options to pass to :ssh.daemon/2. These take precedence and are unchecked.AuthenticationIt's possible to set up a number of authentication strategies with the Erlang SSH daemon. Currently, only simple public key and username/password authentication setups are supported by :nerves_ssh. Both of them work fine for getting started. As needs become more sophisticated, you can pass options to :daemon_option_overrides.Public key authenticationPublic ssh keys can be included in the config.exs so that matching clients can connect. These come from files like your ~/.ssh/id_rsa.pub or ~/.ssh/id_ecdsa.pub that were created when you created your ssh keys. If you haven't done this, the following article may be helpful. Here's an example:config :nerves_ssh, authorized_keys: [ &quot;ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAAAgQDBCdMwNo0xOE86il0DB2Tq4RCv07XvnV7W1uQBlOOE0ZZVjxmTIOiu8XcSLy0mHj11qX5pQH3Th6Jmyqdj&quot;, &quot;ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAACAQCaf37TM8GfNKcoDjoewa6021zln4GvmOiXqW6SRpF61uNWZXurPte1u8frrJX1P/hGxCL7YN3cV6eZqRiF&quot; ]Here's another way that may work well for you that avoids needing to commit your keys:config :nerves_ssh, authorized_keys: [ File.read!(Path.join(System.user_home!, &quot;.ssh/id_rsa.pub&quot;)) ]Username/password authenticationThe SSH console uses public key authentication by default, but it can be configured for usernames and passwords via the :user_passwords key. This has the form [{&quot;username&quot;, &quot;password&quot;}, ...]. Keep in mind that passwords are stored in the clear. This is not recommended for most situations.config :nerves_ssh, user_passwords: [ {&quot;username&quot;, &quot;password&quot;} ]Goals[X] Support public key authentication[X] Support username/password authentication[ ] Device generated server certificate and key[ ] Device generated username/password","ref":"NervesSSH.html","title":"NervesSSH","type":"module"},{"doc":"Read the configuration options","ref":"NervesSSH.html#configuration/0","title":"NervesSSH.configuration/0","type":"function"},{"doc":"Return information on the running ssh daemon.See ssh.daemon_info/1.","ref":"NervesSSH.html#info/0","title":"NervesSSH.info/0","type":"function"},{"doc":"","ref":"NervesSSH.Daemon.html","title":"NervesSSH.Daemon","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"NervesSSH.Daemon.html#child_spec/1","title":"NervesSSH.Daemon.child_spec/1","type":"function"},{"doc":"Read the configuration options","ref":"NervesSSH.Daemon.html#configuration/0","title":"NervesSSH.Daemon.configuration/0","type":"function"},{"doc":"Return information on the running ssh daemon.See ssh.daemon_info/1.","ref":"NervesSSH.Daemon.html#info/0","title":"NervesSSH.Daemon.info/0","type":"function"},{"doc":"","ref":"NervesSSH.Exec.html","title":"NervesSSH.Exec","type":"module"},{"doc":"Run one command coming over ssh","ref":"NervesSSH.Exec.html#run_elixir/1","title":"NervesSSH.Exec.run_elixir/1","type":"function"},{"doc":"Defines option for running the SSH daemon.The following fields are available::authorized_keys - a list of SSH authorized key file string:port - the TCP port to use for the SSH daemon. Defaults to 22.:subsystems - a list of SSH subsystems specs to start. Defaults to SFTP and ssh_subsystem_fwup:system_dir - where to find host keys:shell - the language of the shell (:elixir, :erlang, or :disabled). Defaults to :elixir.:exec - the language to use for commands sent over ssh (:elixir, :erlang, or :disabled). Defaults to :elixir.:iex_opts - additional options to use when starting up IEx:user_passwords - a list of username/password tuples (stored in the clear!):daemon_option_overrides - additional options to pass to :ssh.daemon/2. These take precedence and are unchecked.","ref":"NervesSSH.Options.html","title":"NervesSSH.Options","type":"module"},{"doc":"Return :ssh.daemon_options()","ref":"NervesSSH.Options.html#daemon_options/1","title":"NervesSSH.Options.daemon_options/1","type":"function"},{"doc":"Convert keyword options to the NervesSSH.Options","ref":"NervesSSH.Options.html#new/1","title":"NervesSSH.Options.new/1","type":"function"},{"doc":"Go through the options and fix anything that might crashThe goal is to make options &quot;always work&quot; since it is painful to debug typo's, etc. that cause the ssh daemon to not start.","ref":"NervesSSH.Options.html#sanitize/1","title":"NervesSSH.Options.sanitize/1","type":"function"},{"doc":"","ref":"NervesSSH.Options.html#t:language/0","title":"NervesSSH.Options.language/0","type":"type"},{"doc":"","ref":"NervesSSH.Options.html#t:t/0","title":"NervesSSH.Options.t/0","type":"type"},{"doc":"NervesSSH Manage an SSH daemon and its subsystems on Nerves devices","ref":"readme.html","title":"NervesSSH","type":"extras"},{"doc":"This library wraps Erlang/OTP's SSH daemon to make it easier to use reliably with Nerves devices.Most importantly, it makes it possible to segment failures in other OTP applications from terminating the daemon and it recovers from rare scenarios where the daemon terminates without automatically restarting.If you're using :nerves_pack v0.4.0 or later, you don't need to do anything except, perhaps, modify the :nerves_ssh's configuration in your config.exs. If you are not using :nerves_pack, add :nerves_ssh to your mix dependency list:def deps do [ {:nerves_ssh, &quot;~&gt; 0.1.0&quot;, targets: @all_targets} ] endAnd then include it in :shoehorn's :init list:config :shoehorn, init: [:nerves_runtime, :vintage_net, :nerves_ssh]:nerves_ssh will work if you do not add it to the :init list. However, if your main OTP application stops, OTP may stop :nerves_ssh, and that would make your device inaccessible via SSH.","ref":"readme.html#usage","title":"NervesSSH - Usage","type":"extras"},{"doc":"NervesSSH supports a few pieces of configuration via the application config::authorized_keys - a list of SSH authorized key file string:user_passwords - a list of username/password tuples (stored in the clear!):port - the TCP port to use for the SSH daemon. Defaults to 22.:subsystems - a list of SSH subsystems specs to start. Defaults to SFTP and ssh_subsystem_fwup:system_dir - where to find host keys:shell - the language of the shell (:elixir, :erlang, or :disabled). Defaults to :elixir.:exec - the language to use for commands sent over ssh (:elixir, :erlang, or :disabled). Defaults to :elixir.:iex_opts - additional options to use when starting up IEx:daemon_option_overrides - additional options to pass to :ssh.daemon/2. These take precedence and are unchecked.","ref":"readme.html#configuration","title":"NervesSSH - Configuration","type":"extras"},{"doc":"It's possible to set up a number of authentication strategies with the Erlang SSH daemon. Currently, only simple public key and username/password authentication setups are supported by :nerves_ssh. Both of them work fine for getting started. As needs become more sophisticated, you can pass options to :daemon_option_overrides.Public key authenticationPublic ssh keys can be included in the config.exs so that matching clients can connect. These come from files like your ~/.ssh/id_rsa.pub or ~/.ssh/id_ecdsa.pub that were created when you created your ssh keys. If you haven't done this, the following article may be helpful. Here's an example:config :nerves_ssh, authorized_keys: [ &quot;ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAAAgQDBCdMwNo0xOE86il0DB2Tq4RCv07XvnV7W1uQBlOOE0ZZVjxmTIOiu8XcSLy0mHj11qX5pQH3Th6Jmyqdj&quot;, &quot;ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAACAQCaf37TM8GfNKcoDjoewa6021zln4GvmOiXqW6SRpF61uNWZXurPte1u8frrJX1P/hGxCL7YN3cV6eZqRiF&quot; ]Here's another way that may work well for you that avoids needing to commit your keys:config :nerves_ssh, authorized_keys: [ File.read!(Path.join(System.user_home!, &quot;.ssh/id_rsa.pub&quot;)) ]Username/password authenticationThe SSH console uses public key authentication by default, but it can be configured for usernames and passwords via the :user_passwords key. This has the form [{&quot;username&quot;, &quot;password&quot;}, ...]. Keep in mind that passwords are stored in the clear. This is not recommended for most situations.config :nerves_ssh, user_passwords: [ {&quot;username&quot;, &quot;password&quot;} ]","ref":"readme.html#authentication","title":"NervesSSH - Authentication","type":"extras"},{"doc":"[X] Support public key authentication[X] Support username/password authentication[ ] Device generated server certificate and key[ ] Device generated username/password","ref":"readme.html#goals","title":"NervesSSH - Goals","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]